<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2010 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/profile.php";
include_once "include/site.php";
include_once "include/common.php";

$type = 'label';
$database = site_prolog(PO_USER_TYPE_USER);

$item = pg_escape_string($_REQUEST['item']);

/* Ensure the user owns it !*/
if ($po_user['type'] != PO_USER_TYPE_ADMIN) {
  $result = pg_fetch_row(pg_query($database, "select count(identifier) from 
label where identifier=$item and users=$po_user[id]"));
  if ($result[0] == 0) {
    site_referer_error('not_owner');
    site_epilog($database);
    exit();  
  }
 }

$label = pg_fetch_row(pg_query($database, "
  select label.identifier,
         (select url from manufacturer where identifier=label.manufacturer),
         (select name from manufacturer where identifier=label.manufacturer),
         label.name, paper.name,
         space_x, space_y, label.size_x, label.size_y, offset_x, offset_y,
         columns, rows, date_of_creation
    from label, paper
   where label.paper=paper.identifier
     and label.identifier=$item"));

site_header(sprintf($strings['profile_delete'], $strings['generic_'.$type]));
site_navigator(6);
site_navigator_status(emit_a(generate_link('user', ''), $strings['generic_users'])." : ".emit_a("my.profile.php", $strings['generic_my_profile'])." : ".sprintf($strings['profile_delete'], $strings['generic_'.$type]), "");

theme_display_navigator_box_top($profile_data['label']['idx'], $profile_data, "100%");

print "<form method=\"post\" action=\"profile.del.php\" accept-charset=\"".$strings['formats_encoding']."\">\n";
print "<input type=\"hidden\" name=\"type\" value=\"label\">";
print "<input type=\"hidden\" name=\"go\" value=\"old\"/>\n";
print "<input type=\"hidden\" name=\"item\" value=\"$item\">";
print "<table class=\"profile\">\n";
print "<tr class=\"folder_top\">\n";
print emit_td($strings['generic_delete']." ".$strings['generic_'.$type], 'colspan="12"');
print "</tr>\n";
print "<tr>\n";
print emit_th($strings['profile_model']);
print emit_th($strings['label_h_space']);
print emit_th($strings['label_v_space']);
print emit_th($strings['label_width']);
print emit_th($strings['label_height']);
print emit_th($strings['label_h_offset']);
print emit_th($strings['label_v_offset']);
print emit_th($strings['label_rows']);
print emit_th($strings['label_columns']);
print emit_th($strings['generic_created']);
print "</tr>\n";
print "<tr>\n";
print "<td><a href=\"$label[1]\">$label[2]</a> $label[3], $label[4]</td>\n";
print "<td>$label[5]</td>\n";
print "<td>$label[6]</td>\n";
print "<td>$label[7]</td>\n";
print "<td>$label[8]</td>\n";
print "<td>$label[9]</td>\n";
print "<td>$label[10]</td>\n";
print "<td>$label[11]</td>\n";
print "<td>$label[12]</td>\n";
print "<td>".emit_date_html($label[13], 'date'). "</td>\n";
print "</tr>\n";
print "</table>\n";

print $thm_elem['button.confirm.delete'];
print $thm_elem['button.cancel'];
print "</form>\n";

theme_display_navigator_box_bottom("100%");

site_footer($database);
site_epilog($database);
?>
