<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2010 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/profile.php";
include_once "include/site.php";
include_once "include/calendar.php";

function add_item($database, $user_id, $type,
                  $sku, $manufacturer_id, $model,
                  $serial_number, $purchase_timestamp,
                  $purchased_new, $access_rights, $url) {
  global $strings;

  $date_of_purchase = check_date_validity($purchase_timestamp);
  $type = pg_escape_string($type);

  $sku = pg_escape_string($sku);
  $url = pg_escape_string($url);
  $manufacturer_id = pg_escape_string($manufacturer_id);

  $model = pg_escape_string($model);
  $serial_number = pg_escape_string($serial_number);

  $purchased_new = pg_escape_string($purchased_new);
  $access_rights = pg_escape_string($access_rights);

  pg_query($database, "begin");
  $result = TRUE;
  if ($sku=='custom') {
    $new_sku = pg_fetch_row(pg_query($database, "select nextval('equipment_sku_id_seq')"));
    $sku = $new_sku[0];
    $result = pg_query($database, "insert into equipment_sku (identifier, manufacturer, model, type, url)
                                   values ($sku, $manufacturer_id, '$model', $type, '$url')");
  }

  if ($result) {
    $result = pg_query($database, "insert into equipment (identifier, sku, users, serial, purchase_date, purchased_new, access_rights)
                                 values (nextval('equipment_id_seq'), '$sku', '$user_id', '$serial_number', $date_of_purchase, '$purchased_new', '$access_rights')");
  }

  if ($result) {
    pg_query($database, "commit");
  } else {
    pg_query($database, "rollback");
    site_push_error($strings['errors_db_insert_failed']);
  }
}

$database = site_prolog(PO_USER_TYPE_USER);

$type = $_REQUEST['type'];

add_item($database, $po_user['id'], $type,
	 $_REQUEST['sku'], 
	 $_REQUEST['manufacturer_id'], 
	 $_REQUEST['model'], 
	 $_REQUEST['serial'], 
	 $_REQUEST['purchase_timestamp'], 
	 $_REQUEST['purchased_new'], 
	 $_REQUEST['access_rights'],
	 $_REQUEST['url']);

site_epilog($database);
header("Location: my.profile.php?selector=".$profile_data[$equipment_types[$type]]['idx']);
?>
