<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2010 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/profile.php";
include_once "include/site.php";
include_once "include/common.php";

$database = site_prolog(PO_USER_TYPE_USER);

$type = pg_escape_string($_REQUEST['type']);
$manufacturer_filter = pg_escape_string(isset($_REQUEST['filter']) ? $_REQUEST['filter'] : "");

$manufacturer = get_generic_query_all($database, "select identifier, name from manufacturer order by name", 'manuf_all');

switch ($manufacturer_filter) {
 case 'All':
 case '':
   $skus = pg_query($database, "select identifier, name, model, m_url from view_equipment_sku where type=$type");
   break;
 default:
   $skus = pg_query($database, "select identifier, name, model, m_url from view_equipment_sku where type=$type and name='$manufacturer_filter'");
}

site_header(sprintf($strings['profile_add'], $strings['generic_'.$equipment_types[$type]]));
site_navigator(6);
site_navigator_status(emit_a(generate_link('user', ''), $strings['generic_users'])." : ".emit_a("my.profile.php", $strings['generic_my_profile'])." : ".sprintf($strings['profile_add'], $strings['generic_'.$equipment_types[$type]]), "");

theme_display_navigator_box_top($profile_data[$equipment_types[$type]]['idx'], $profile_data, "100%");

if (sizeof($manufacturer) == 0) {
  print emit_manuf_add_needed($equipment_types[$type]);
  theme_display_navigator_box_bottom("100%");
  site_footer($database);
  site_epilog($database);
  exit;
}

print "<form method=\"post\" action=\"profile.add.2.php\" accept-charset=\"".$strings['formats_encoding']."\">\n";
print "<table class=\"profile\">\n";

print emit_profile_manuf_combo("profile.add.php?type=$type", $equipment_types[$type], 2, $manufacturer, $manufacturer_filter);

print "<tr>\n";
print "<th width=\"5%\"></th>\n";
print emit_th($strings['profile_manufacturer'], "width=\"35%\"");
print emit_th($strings['profile_model'], "width=\"45%\"");
print "</tr>\n";

print "<input type=\"hidden\" name=\"type\" value=\"$type\" />\n";
$num = pg_num_rows($skus);
if ($num > 0) {
  for ($i=0; $i < $num; $i++) {
    $r = pg_fetch_assoc($skus, $i);
    print "<tr>\n";
    print "<td><input type=\"radio\" name=\"sku\" value=\"$r[identifier]\"/></td>\n";
    print "<td><a href=\"$r[m_url]\">$r[name]</a></td>\n";
    print "<td>$r[model]</td>\n";
    print "</tr>\n";
  }
} else
  print "<tr><td colspan=\"3\">".sprintf($strings['profile_none_found'], $strings['generic_'.$equipment_types[$type]])." ".$strings['generic_types'] ."</td></tr>\n";

print "</table>\n";

print "<table class=\"profile\">\n";
print "<tr class=\"folder_top\">\n";
print "<td colspan=\"4\">".sprintf($strings['profile_new_type'], $strings['generic_'.$equipment_types[$type]])."</td>\n";
print "</tr>\n";
print "<tr>\n";
print "<th width=\"5%\"></th>\n";
print emit_th($strings['profile_manufacturer'], "width=\"25%\"");
print emit_th($strings['profile_model'], "width=\"35%\"");
print emit_th($strings['user_web'], "width=\"35%\"");
print "</tr>\n";

print "<tr>\n";
print "<td><input type=\"radio\" name=\"sku\" value=\"custom\" checked/></td>\n";
print "<td>";
print emit_manufacturer_combo('manufacturer_id', $manufacturer, "");
print "</td>\n";
print "<td><input type=\"text\" name=\"model\"/></td>\n";
print "<td><input type=\"text\" name=\"url\"/></td>\n";
print "</tr>\n";
print "</table>\n";

print "<table class=\"profile\">\n";
print "<tr class=\"folder_top\"><td colspan=\"4\">".sprintf($strings['profile_specific_data'], $strings['generic_'.$equipment_types[$type]])."</td></tr>\n";

print "<tr>\n";
print emit_th($strings['profile_serial']);
print emit_th($strings['profile_purchased']);
print emit_th($strings['profile_new']);
print emit_th($strings['generic_access']);
print "</tr>\n";

print "<tr>\n";
print "<td><input type=\"text\" name=\"serial\"/></td>\n";
print "<td>\n";
print emit_date_input_form("purchase_timestamp", "");
print "</td>\n";
print "<td>\n"; print emit_yes_no_combo("purchased_new", "t"); print "</td>\n";
print "<td>\n"; print emit_access_combo("access_rights", "t", ""); print "</td>\n";
print "</tr>\n";
print "</table>\n";

print $thm_elem['button.add'];
print $thm_elem['button.clear'];
print $thm_elem['button.cancel'];
print "</form>\n";

theme_display_navigator_box_bottom("100%");

site_footer($database);
site_epilog($database);
?>
